<template>
  <div class="pages-background">
    <v-container fluid>
      <v-row no-gutters>
        <v-spacer />
        <v-col>
          <div class="header">
            <p>
              <span>{{ $t('header.welcome') }}</span>
              <v-icon class="icon">
                mdi-pig
              </v-icon>
            </p>
            <p>{{ $t('header.cta1') }}</p>
            <p>{{ $t('header.cta2') }}</p>
          </div>
          <v-form
            id="register-form"
            @submit.prevent="onSubmit"
          >
            <first-name-field
              v-model="$v.form.firstName.$model"
              solo
              prepend-inner-icon="mdi-account"
              :error-messages="firstNameValidations"
              :disabled="isLoading"
              required-flag
            />
            <last-name-field
              v-model="$v.form.lastName.$model"
              solo
              prepend-inner-icon="mdi-account"
              :error-messages="lastNameValidations"
              :disabled="isLoading"
              required-flag
            />
            <email-field
              v-model="$v.form.email.$model"
              solo
              required-email
              :error-messages="emailValidations"
              :disabled="isLoading"
              @emailAddressAvailable="isEmailAvailable = $event"
            />
            <password-field
              v-model="$v.form.password.$model"
              solo
              required-password
              :error-messages="passwordValidations"
              :disabled="isLoading"
            />
            <password-confirmation-field
              v-model="$v.form.passwordConfirmation.$model"
              solo
              required-password-confirmation
              :error-messages="passwordConfirmationValidations"
              :disabled="isLoading"
            />
            <p class="mandatory-filling-notice">
              {{ $t('mandatoryFillingNotice') }}
            </p>
            <div class="d-flex">
              <v-spacer />
              <router-link
                :to="{ name: 'LoginPage' }"
                class="go-back-link"
              >
                <span>{{ $t('goBack') }}</span>
              </router-link>
              <v-btn
                type="submit"
                :loading="isLoading"
              >
                {{ $t('register') }}
              </v-btn>
            </div>
          </v-form>
        </v-col>
        <v-spacer />
      </v-row>
    </v-container>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate'
  import { required, minLength, maxLength, sameAs, email } from 'vuelidate/lib/validators'

  const formInitialState = {
    firstName: '',
    lastName: '',
    email: '',
    password: '',
    passwordConfirmation: '',
  }

  export default {
    name: 'Register',
    mixins: [validationMixin],
    validations: {
      form: {
        firstName: {
          required,
          maxLength: maxLength(32),
        },
        lastName: {
          required,
          maxLength: maxLength(64),
        },
        email: {
          email,
          required,
          maxLength: maxLength(255),
        },
        password: {
          required,
          minLength: minLength(8),
          maxLength: maxLength(64),
        },
        passwordConfirmation: {
          sameAs: sameAs('password'),
        },
      },
    },
    data () {
      return {
        isLoading: false,
        isEmailAvailable: null,
        form: formInitialState,
      }
    },
    computed: {
      firstNameValidations () {
        const firstName = this.$v.form.firstName
        if (!firstName.$dirty) {
          return ''
        }
        return !firstName.required
          ? this.$t('global.validations.required')
          : !firstName.maxLength
            ? this.$t('global.validations.maxLength', { n: firstName.$params.maxLength.max })
            : ''
      },
      lastNameValidations () {
        const lastName = this.$v.form.lastName
        if (!lastName.$dirty) {
          return ''
        }
        return !lastName.required
          ? this.$t('global.validations.required')
          : !lastName.maxLength
            ? this.$t('global.validations.maxLength', { n: lastName.$params.maxLength.max })
            : ''
      },
      emailValidations () {
        const email = this.$v.form.email
        if (!email.$dirty) {
          return ''
        }
        return !email.required
          ? this.$t('global.validations.required')
          : !email.maxLength
            ? this.$t('global.validations.maxLength', { n: email.$params.maxLength.max })
            : !email.email
              ? this.$t('global.validations.email')
              : this.isEmailAvailable !== null && !this.isEmailAvailable
                ? this.$t('global.validations.emailUnavailable')
                : ''
      },
      passwordValidations () {
        const password = this.$v.form.password
        if (!password.$dirty) {
          return ''
        }
        return !password.required
          ? this.$t('global.validations.required')
          : !password.maxLength
            ? this.$t('global.validations.maxLength', { n: password.$params.maxLength.max })
            : !password.minLength
              ? this.$t('global.validations.minLength', { n: password.$params.minLength.min })
              : ''
      },
      passwordConfirmationValidations () {
        const passwordConfirmation = this.$v.form.passwordConfirmation
        if (!passwordConfirmation.$dirty) {
          return ''
        }
        return !passwordConfirmation.sameAs
          ? this.$t('global.validations.sameAs')
          : ''
      },
    },
    methods: {
      onSubmit () {
        const form = this.$v.form
        form.$touch()
        if (!form.$anyError && this.isEmailAvailable) {
          this.isLoading = true
          this.$store.dispatch('auth/register', { ...this.form })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('registerSuccess'),
              })
              this.$router.push({ name: 'LoginPage' }).catch(() => {})
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('registerError'),
              })
            })
            .finally(() => {
              this.isLoading = false
            })
        }
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          header: {
            welcome: 'Que bom tê-lo por aqui!',
            cta1: 'Comece a cuidar do seu dinheiro hoje mesmo.',
            cta2: 'Para criar sua conta, basta informar os dados solicitados abaixo.',
          },
          mandatoryFillingNotice: 'Os campos marcados com asterisco (*) são obrigatórios.',
          goBack: 'Voltar',
          register: 'Cadastrar',
          registerError: 'Ops... Ocorreu um erro ao tentar criar sua conta. Por favor, tente novamente.',
          registerSuccess: 'Conta criada com sucesso!',
        },
        'en-US': {
          header: {
            welcome: 'Good to have you here!',
            cta1: 'Start taking care of your money today.',
            cta2: 'To create your account, just enter the data requested below.',
          },
          mandatoryFillingNotice: 'Fields marked with an asterisk (*) are required.',
          goBack: 'Go back',
          register: 'Register',
          registerError: 'Oops... There was an error trying to create your account. Please try again.',
          registerSuccess: 'Account created successfully!',
        },
      },
    },
  }
</script>

<style lang="scss" scoped>
.header {
  text-align: center;
  font-size: large;
  font-family: "Comic Sans MS", sans-serif;
  p {
    margin-bottom: 1rem;
  }
  .icon {
    color: deeppink;
    margin-left: 0.3rem;
  }
}
.d-flex {
  display: flex;
  align-items: flex-end;
}
.go-back-link {
  margin-right: 2rem;
  text-decoration: none;
  color: #0645AD;
  &:hover {
    text-decoration: underline;
  }
}
.mandatory-filling-notice {
  font-size: small;
  font-style: italic;
}
</style>

<style lang="scss">
#register-form {
  .v-messages__message {
    color: red;
  }
}
</style>
